!= Module StoreNudging
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: storemixrt.f90,v 1.1 2007-06-09 13:15:40 sugiyama Exp $ 
! Tag Name::  $Name: arare4-20100910 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!˴ؤѻͤݴɤ뤿ѿ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module StoreNudging
  !
  !ѻͤݴɤ뤿ѿ⥸塼.
  !

  !⥸塼ɤ߹
  use gridset, only:   DimXMin,     & ! x β
    &                  DimXMax,     & ! x ξ
    &                  DimZMin,     & ! z β
    &                  DimZMax,     & ! z ξ
    &                  SpcNum,      & ! number of species
    &                  RegXMin,     & ! x ʪΰβ
    &                  RegXMax        ! x ʪΰξ
  use TimeSet, only:   TimeDisp,    & ! ϻֳִ
    &                  DelTimeLong    ! Ĺ֥ƥå

  !ۤηػ
  implicit none

  !°λ
  private

  !
  public StoreNudging_Init, StoreNudgingMeanX, StoreNudgingClean
  public za_Nudging, xza_Nudging
  public StoreNudgingMixRt

  !ѿ
  real(8), allocatable :: za_Nudging(:,:)
  real(8), allocatable :: xza_Nudging(:,:,:)

  save xza_Nudging
  save za_Nudging
  
contains

  subroutine StoreNudging_Init( )
    !롼

    allocate(     &
      & za_Nudging(DimZMin:DimZMax, SpcNum),   & 
      & xza_Nudging(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)   & 
      &  )
    
    call StoreNudgingClean()

  end subroutine StoreNudging_Init


  subroutine StoreNudgingClean( )
    !ݴɤͤΥꥢ
    
    za_Nudging  = 0.0d0

    xza_Nudging  = 0.0d0

!    CalNum  = 1.0d-40   !ػ
  end subroutine StoreNudgingClean


  subroutine StoreNudgingMeanX( )
    !ݴɤͤοʿʿ
 
    real(8) :: CalNum

    CalNum = TimeDisp / DelTimeLong
   
    za_Nudging  = aa_MeanX_aaa( xza_Nudging ) / CalNum

  end subroutine StoreNudgingMeanX


  subroutine StoreNudgingMixRt( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)

    Work2  = xza_Nudging + Work
    xza_Nudging = Work2

!    CalNum = CalNum + 1

  end subroutine StoreNudgingMixRt

  function aa_MeanX_aaa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: aa_MeanX_aaa(DimZMin:DimZMax, SpcNum)
                                     !ʿʿ

    aa_MeanX_aaa = sum( var(RegXMin+1:RegXMax,:,:), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 
    
  end function aa_MeanX_aaa
  
  
end module StoreNudging
